
package simple;

import java.awt.*;
import java.io.Serializable;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

public class Simple extends Canvas implements
	PropertyChangeListener, ItemListener, Serializable {
  private Color favouriteColor;
  public Simple() {
    setBackground(Color.red);
    favouriteColor = Color.red;
  }

  public Dimension getMinimumSize() {
    return new Dimension(50, 50);
  }

  public void propertyChange( PropertyChangeEvent pe ) {
	if (pe.getPropertyName() == "background") 
		setBackground( (Color)pe.getNewValue() );
	if (pe.getPropertyName() == "foreground") 
		setForeground( (Color)pe.getNewValue() );
  }

  public void itemStateChanged( ItemEvent ie ) {
	Color temp = getForeground();
	setForeground( getBackground() );
	setBackground( temp );
  }

// uncomment to add a simple property
  public synchronized void setFavouriteColor( Color val ) {
	setBackground( val );
	setForeground( val );
	this.favouriteColor = val;
  }
  public Color getFavouriteColor() {
	return this.favouriteColor;
  }
}
